
/* Copyright (C) 2004 whoosh777@blueyonder.co.uk  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file whoosh_LICENSE in this distribution.
  
  For more information about licensing, please email 
  whoosh777@blueyonder.co.uk
  For information on commercial licensing, email whoosh777@blueyonder.co.uk

  sometimes I may be away from the internet for several weeks, if I am 
  on the internet then I respond quickly to emails,

  My GS813 homepage http://www.whoosh777.pwp.blueyonder.co.uk
*/

/*
if you want your changes to this file to be maintained by whoosh777@blueyonder.co.uk,

ie as I develop further the viewers that the improvements should propagate 
through, 

then you must email me and I will send the current source + 
allocate you a time slot where my own development is "frozen" + 
I will give you rules to be followed in order for your changes to become 
incorporated.

the rules for this are much stricter than AFPL's rules,
this is because this is work in progress,

note also that such changes then become my private property to 
 use however I wish, you can also do whatever you wish with these changes 
ie they split into 2 copies one belongs to me, one belongs to you,

*/
/*
#include <std.h>
for gcc:
*/

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>

/*
#include <iff/iff_data.h>
*/

#include <exec/types.h>
#include <exec/ports.h>
#include <exec/devices.h>
#include <exec/memory.h>
#include <devices/printer.h>
#include <devices/prtbase.h>
#include <dos/dos.h>

#include <cybergraphx/cybergraphics.h>
#include <intuition/intuition.h>
#include <intuition/screens.h>

#include "protos.h"

/*
#include <proto/exec.h>
#include <proto/intuition.h>
#include <proto/graphics.h>
*/

/* some new Includes */
#include "turboprint.h"


#include "turboprefs.h"


#include "write8.h"

union printerIO
{
	struct IORequest ior ; /* whoosh! */
	struct IOStdReq	ios;
	struct IODRPReq	iodrp;
	struct IOPrtCmdReq iopc;
};

/* for turbo_data->flags */
#define TURBO_WAIT	1 
#define TURBO_PRESENT	2 
#define	TURBO_CLOSEDEVICE 4
#define	TURBO_SUCCESS	8
#define	TURBO_FULLCOLOUR	16
#define	TURBO_256G	32
#define	TURBO_1	 	64

/* dont forget that extra * after void: */
typedef void *(*USER_CALLOC)( void *user , int size , int num ) ;

typedef void (*USER_FREE)( void *user , void *mem ) ;

typedef void (*USER_MESS)( void *user , const char *mess ) ;

/*
typedef int (*user_num)( struct turbo_data_s *td , int num ) ;
*/

typedef 
struct turbo_data_s
	{ 
	/* everything is filled in by turbo_alloc( , ) */
	/* user accesses nothing in here, all access via functions */
	
	struct MsgPort *mp;
	union printerIO *pio;

	struct TPExtIODRP *tp_ext;
	struct RastPort *rp1 , *rp2  ;
	struct BitMap *bm1 , *bm2 ;
	int width , height , Height , done , Done , planes /* for AmigaOS */ ;
	int flags , density ;

	int turbofactor ; /* bytes per pixel */

	double fxdpi , fydpi;/* if any, lift from gs8 pdev->HWResolution[ 0 , 1] */

	struct ColorMap *cm ;

	unsigned char *no , *yes ;

	const char *name ; /* dont free */
	int pri ;

	void *user ; /* for user use */

	USER_CALLOC user_calloc ;
	USER_FREE user_free ;
	USER_MESS user_mess ;
	int (*user_num)( struct turbo_data_s *td , int num ) ;
	/* allocated + freed, but not actually used currently */
	UBYTE *temp_array ;
	struct RastPort *temp_rp ;
	} 	
	
	turbo_data ;


int turbo(int Width , int Height , unsigned char *rgb ) ;

unsigned char *turbo_rgb( turbo_data *td ) ;


/* values for method in turbo_alloc */
/* use TURBO_FULLCOLOUR and TURBO_256G instead, too easy to get a bug.
#define		METHOD_4096	1
#define		METHOD_256G	2
*/
turbo_data *turbo_alloc( const char *name , int pri , int width , int height , 
			int density , int Height , 
		void *user , USER_CALLOC user_calloc , USER_FREE user_free ,
		USER_MESS user_mess ,
		int method 
			) ;

/* WARNING: rgb must not be accessed after this call!!! */
/* use double buffering, send rgb1, prepare rgb2, send rgb2, prepare rgb1 etc */
/* With flush, it waits for completion! usually rgb==0 */

void turbo_print(turbo_data *td , int height , int flush ) ;

void turbo_free( turbo_data *td ) ;

void turbo_look( turbo_data *td ) ;

int turbo_is( union printerIO *pio , turbo_data *td ) ; /* td just for echoes */

void turbo_write_rgb_rows( turbo_data *td , unsigned char *rgb , int rows ,
		int quit ) ;

void whoosh_SetRGB32CM( struct ColorMap *cm , unsigned n , unsigned r , 
	unsigned g , unsigned b ) ;

void whoosh_SetRGB32( struct ViewPort *vp , unsigned n , unsigned r , 
	unsigned g , unsigned b ) ;

int env_int( const char *name , int defaultval ) ;

double env_double( const char *name , double defaultval ) ;

struct IODRPReq *turbo_io( turbo_data *td ) ;

struct IODRPReq *pio_io( union printerIO *pio ) ;

struct PrinterData *turbo_pd( turbo_data *td ) ;

struct PrinterData *pio_pd( union printerIO *pio ) ;

struct PrinterExtendedData *turbo_ped( turbo_data *td ) ;

struct PrinterExtendedData *pio_ped( union printerIO *pio ) ;

struct Preferences *turbo_prefs( turbo_data *td ) ;

struct Preferences *pio_prefs( union printerIO *pio ) ;

/* intuition.c */
int intuition(void) ;
int intuition_open(void) ;
void intuition_close(void);

/* asl.c */
int asl(void) ;
int asl_open(void) ;
void asl_close(void);

/* cyber.c */
int cyber(void) ;
int cyber_open(void) ;
void cyber_close(void);

/* graphics.c */
int graphics(void) ;
int graphics_open(void) ;
void graphics_close(void);

